# Tutorials

This section provides a number of tutorials to provide guidance on using the MIMIC-III database. Tutorials are provided either as plain-text (`.md`), Jupyter Notebooks (`.ipynb`), or R Markdown files (`.Rmd`). If downloaded locally, the latter two tutorials are interactive, otherwise all tutorials can be viewed online.

The tutorials currently available include:

* cohort-selection.ipynb - Overviews selecting a cohort of patients from MIMIC-III. Topics include calculating patient ages, service type, and creating exclusion criteria.
* explore-items.Rmd - Exploring the data associated with various `itemid` in MIMIC-III, with specific focus on contrasting how there are two sources of data: CareVue and MetaVision.
* sql-intro.md - A gentle introduction to using Structured Query Language (SQL) with the MIMIC-III database, covering key tables and important SQL keywords.
* using_r_with_jupyter.ipynb - Demonstration of using a Jupyter Notebook with the R kernel to connect to a PostgreSQL database with MIMIC-III
